<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Document</title>
</head>

<body>
    <button onclick="quad()" >Adicionar Box</button>
    <div id=divs>
    </div>
    <script>
        var body = document.querySelector("#divs")

        function quad() {
            var box = document.createElement("div")
            box.style.width = "100px"
            box.style.height = "100px"
            box.style.backgroundColor = "red"
            box.style.margin = "10px"
            box.onmouseover = function() {novaCor(this)}
            body.appendChild(box)
        }

        function getRandomColor() {
            var letters = "0123456789ABCDEF";
            var color = "#";
            for (var i = 0; i < 6; i++) {
                color += letters[Math.floor(Math.random() * 16)];
            }
            return color;
        }

        function novaCor(div){
            div.style.backgroundColor = getRandomColor()
        }
    </script>
</body>

</html>